# Dark Decoy's Ansible Style Guide

- [General Rules](#general-rules)
- [Documentation](#documentation)
  - [Ansible Doctor](#ansible-doctor)
  - [\[WIP\] Playbooks](#wip-playbooks)
  - [\[WIP\] Roles](#wip-roles)
  - [\[WIP\] Collection](#wip-collection)
- [\[WIP\] Playbooks](#wip-playbooks-1)
- [\[WIP\] Inventory](#wip-inventory)
  - [Group Vars](#group-vars)
  - [Host Vars](#host-vars)
  - [Vaults](#vaults)
  - [hosts file](#hosts-file)
- [\[WIP\] Roles](#wip-roles-1)
  - [General Rules for Roles](#general-rules-for-roles)
  - [Structure](#structure-1)
  - [Variables (defaults and vars)](#variables-defaults-and-vars)
  - [\[WIP\] Files](#wip-files)
  - [\[WIP\] Handlers](#wip-handlers)
  - [LICENSE](#license)
  - [Meta](#meta)
  - [Tasks](#tasks)
  - [Tags](#tags)
  - [Templates](#templates)
- [\[WIP\] Collections](#wip-collections)
- [Debugging](#debugging)
- [Sources](#sources)
  - [Ansible Documentation](#ansible-documentation)
  - [Style Guides](#style-guides)
  - [Best Practices](#best-practices)
  - [Example Playbooks](#example-playbooks)
  - [Tools](#tools)

## General Rules
- Always name plays, tasks and blocks. It should be clear what they are doing.

## Documentation

### Ansible Doctor
Ansible-doctor is used 
### [WIP] Playbooks

### [WIP] Roles

### [WIP] Collection

## [WIP] Playbooks
In general, playbooks should look like the following beginning with three dashes, a hosts variable and list of roles.

```yaml
---
- hosts: openemr

  roles:
    - role: base
    - role: apache
    - role: mysql
    - role: php
    - role: openemr
    - role: ssl
```

As a general rule of thumb all tasks should be inside of roles unless absolutely necessary like adding personal customizations to the altispeed laptop playbook then the playbook would look like the following.

```yaml
---
- hosts: darkdecoy

  roles:
    - role: base
    - role: laptop

  tasks:
    - name: Installing Jitsi Meet Flatpak
      flatpak:
        name: org.jitsi.jitsi-meet
        state: present

    - name: Install Meld
      package:
        name:
          - meld
        state: present
      become: true

    - name: Install G510s Utilities
      package:
        name:
          - g510s
          - g15daemon
          - xdotool
          - g15stats
        state: present
      become: true
```

## [WIP] Inventory
### Group Vars

### Host Vars

### Vaults

### hosts file
#### Name

#### Structure

## [WIP] Roles
### General Rules for Roles
- Start with skeleton generated by ansible-galaxy
- Role should do one thing and no more to reduce the complexity and increase their stability (i.e. the lamp stack should be deployed using 3 roles (mysql, apache and php) instead of one role)
- Roles should support at least the latest version of Almalinux and Ubuntu unless they really on docker
- For Docker based roles, the latest version Ubuntu should be supported
- If possible ocker based should look to add podman support

### Structure

| Name      | Type   | Description                                                                                                          | Required |
| --------- | ------ | -------------------------------------------------------------------------------------------------------------------- | -------- |
| defaults  | folder | Contains default variables in main.yml which will likely be overridden when the inventory is added before deployment | True     |
| files     | folder | Contains files to be copied to the ansible host                                                                      | False    |
| handlers  | folder | Contains handlers in a main.yml                                                                                      | False    |
| LICENSE   | file   | Contains the license for the role                                                                                    | True     |
| meta      | folder | Contains the metadata information of the role                                                    | True     |
| README.md | file   | This should be generated using ansible-doctor                                                                        | True     |
| tasks     | folder | Contains play files which at least needs to be main.yml but can contain other play files                             | True     |
| templates | folder | Contains template files to be used with jinja2 templating and the template module                                    | False    |
| vars      | folder | Contains variables which can not be overridden by the inventory                                                      | True     |

### Variables (defaults and vars)
- All role variables should begin with name of the role followed by an underscore and then a descriptive name of what the variable holds (i.e. base role variables would begin with base_)

### [WIP] Files

### [WIP] Handlers

### LICENSE
Roles should be licensed GPLv3 unless they have a different license requirement

### Meta
The meta folder contains one file called main.yml and this information like author name, role name, namespace, license, minimum ansible version required, ansible galaxy tags, any roles that this role depends upon and what platforms are supported.

### Tasks
The tasks folder primarily contains the main.yml play but other plays can and often will be added and then imported into the main.yml play using import_tasks or include_tasks modules. Other plays should be used to help organize tasks and to keep any one task file from getting to large and hard to understand.  Other common plays to be used are install, setup, secure, backup, restore and uninstall.

#### Rules
- The name of every task in a play should begin with the name of the play followed by a dash (i.e. install play task names would begin with Install - ). The only exception to this would be the main play where no prefix is needed.  This makes it easy to where you are in the execution of role and when there is an error you can easily tell what file the failed task is in.

### Tags

### Templates

## [WIP] Collections

## Debugging
* ansible <hostname> -m ansible.builtin.setup
* -vvv vs -vvvv

## Sources

### Ansible Documentation
- [Variable Precedence](https://docs.ansible.com/ansible/latest/playbook_guide/playbooks_variables.html#variable-precedence-where-should-i-put-a-variable)
- [Discovering variables: facts and magic variables](https://docs.ansible.com/ansible/latest/playbook_guide/playbooks_vars_facts.html)
- [Conditionals](https://docs.ansible.com/ansible/latest/playbook_guide/playbooks_conditionals.html)
- [Ansible tips and tricks](https://docs.ansible.com/ansible/latest/tips_tricks/index.html)

### Style Guides
- [Style Guide for EGI Ansible](https://docs.egi.eu/ansible-style-guide/about)
- [Ansible Role style guide](https://docs.egi.eu/ansible-style-guide/ansible-syntax)
- [Whitecloud Ansible Styleguide](https://github.com/whitecloud/ansible-styleguide)

### Best Practices
- [Ansible Best Practices: The Essentials](https://www.ansible.com/blog/ansible-best-practices-essentials)

### Example Playbooks
- [matrix-docker-ansible-deploy](https://github.com/spantaleev/matrix-docker-ansible-deploy)

### Tools
- [Ansible-Doctor](https://ansible-doctor.geekdocs.de/)
- [Ansible-Later](https://ansible-later.geekdocs.de/)
- [Ansible-Lint](https://ansible-lint.readthedocs.io/)
- [Molecule](https://molecule.readthedocs.io/)

[Back](../README.md)
